<template>
  <Dialog title="企业登录邮箱修改" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
      @submit.prevent
    >
      <el-form-item label="企业邮箱" prop="email">
        <el-input v-model="formData.email" placeholder="请输入企业邮箱" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script setup lang="ts">
import { EnterpriseUserBindApi } from '@/api/menduner/system/enterprise/userBind'

defineOptions({ name: 'EnterpriseUserBindForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formData = ref({
  id: undefined,
  email: undefined
})

const validateEmail = (rule: any, value: any, callback: any) => {
  if (!value) {
    callback(new Error('请输入企业邮箱'))
  } else {
    if (!/^[^\s@]+@[^\s@]+\.[^\s@]+$/.test(value)) {
      callback(new Error('请输入正确的企业邮箱地址'))
    }
    callback()
  }
}

const formRules = reactive({
  email: [{ required: true, validator: validateEmail, trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (id: number) => {
  dialogVisible.value = true
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      const data = await EnterpriseUserBindApi.getEnterpriseUserBind(id)
      formData.value.id = data.id
      formData.value.email = data.email
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    await EnterpriseUserBindApi.updateEnterpriseEmail(formData.value)
    message.success(t('common.updateSuccess'))
    dialogVisible.value = false
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    email: undefined
  }
  formRef.value?.resetFields()
}
</script>